# Class LinkedHashMap<K,V>

java.lang.Object
java.util.AbstractMap<K,V>
java.util.HashMap<K,V>
java.util.LinkedHashMap<K,V>

All Implemented Interfaces:
  `Map<K,V>`

public class LinkedHashMap<K,V> extends HashMap<K,V> implements Map<K,V>

LinkedHashMap is a variant of HashMap. Its entries are kept in a doubly-linked list. The iteration order is, by default, the order in which keys were inserted. Reinserting an already existing key doesn't change the order. A key is existing if a call to `containsKey` would return true.

If the three argument constructor is used, and `order` is specified as `true`, the iteration will be in the order that entries were accessed. The access order gets affected by put(), get(), putAll() operations, but not by operations on the collection views.

Null elements are allowed, and all the optional map operations are supported.

Note: The implementation of `LinkedHashMap` is not synchronized. If one thread of several threads accessing an instance modifies the map structurally, access to the map needs to be synchronized. For insertion-ordered instances a structural modification is an operation that removes or adds an entry. Access-ordered instances also are structurally modified by put(), get() and putAll() since these methods change the order of the entries. Changes in the value of an entry are not structural changes.

The Iterator that can be created by calling the `iterator` method throws a `ConcurrentModificationException` if the map is structurally changed while an iterator is used to iterate over the elements. Only the `remove` method that is provided by the iterator allows for removal of elements during iteration. It is not possible to guarantee that this mechanism works in all cases of unsynchronized concurrent modification. It should only be used for debugging purposes.

##### Since

1.4

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class AbstractMap

  `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

  ### Nested classes/interfaces inherited from interface Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LinkedHashMap()`
  Constructs a new empty `LinkedHashMap` instance.
  `LinkedHashMap(int s)`
  Constructs a new `LinkedHashMap` instance with the specified capacity.
  `LinkedHashMap(int s, float lf)`
  Constructs a new `LinkedHashMap` instance with the specified capacity and load factor.
  `LinkedHashMap(int s, float lf, boolean order)`
  Constructs a new `LinkedHashMap` instance with the specified capacity, load factor and a flag specifying the ordering behavior.
  `LinkedHashMap(Map<? extends K, ? extends V> m)`
  Constructs a new `LinkedHashMap` instance containing the mappings from the specified map.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Removes all elements from this map, leaving it empty.
  `boolean`
  `containsValue(Object value)`
  Returns whether this map contains the specified value.
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a set containing all of the mappings in this map.
  `V`
  `get(Object key)`
  Returns the value of the mapping with the specified key.
  `Set<K>`
  `keySet()`
  Returns a set of the keys contained in this map.
  `V`
  `put(K key, V value)`
  Maps the specified key to the specified value.
  `V`
  `remove(Object key)`
  Removes the mapping with the specified key from this map.
  `protected boolean`
  `removeEldestEntry(Map.Entry<K,V> eldest)`
  This method is queried from the put and putAll methods to check if the eldest member of the map should be deleted before adding the new member.
  `Collection<V>`
  `values()`
  Returns a collection of the values contained in this map.

  ### Methods inherited from class HashMap

  `containsKey, isEmpty, putAll, size`

  ### Methods inherited from class AbstractMap

  `equals, hashCode, toString`

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Map

  `compute, computeIfAbsent, computeIfPresent, containsKey, equals, forEach, getOrDefault, hashCode, isEmpty, merge, putAll, putIfAbsent, remove, replace, replace, replaceAll, size`

- ## Constructor Details

  - ### LinkedHashMap

    public LinkedHashMap()
    Constructs a new empty `LinkedHashMap` instance.

  - ### LinkedHashMap

    public LinkedHashMap(int s)

    Constructs a new `LinkedHashMap` instance with the specified capacity.

    ###### Parameters

    - `s`: the initial capacity of this map.

    ###### Throws

    - `IllegalArgumentException`: if the capacity is less than zero.

  - ### LinkedHashMap

    public LinkedHashMap(int s, float lf)

    Constructs a new `LinkedHashMap` instance with the specified capacity and load factor.

    ###### Parameters

    - `s`: the initial capacity of this map.

    - `lf`: the initial load factor.

    ###### Throws

    - `IllegalArgumentException`: @throws IllegalArgumentException when the capacity is less than zero or the load factor is less or equal to zero.

  - ### LinkedHashMap

    public LinkedHashMap(int s, float lf, boolean order)

    Constructs a new `LinkedHashMap` instance with the specified capacity, load factor and a flag specifying the ordering behavior.

    ###### Parameters

    - `s`: the initial capacity of this hash map.

    - `lf`: the initial load factor.

    - `order`: @param order `true` if the ordering should be done based on the last access (from least-recently accessed to most-recently accessed), and `false` if the ordering should be the order in which the entries were inserted.

    ###### Throws

    - `IllegalArgumentException`: @throws IllegalArgumentException when the capacity is less than zero or the load factor is less or equal to zero.

  - ### LinkedHashMap

    public LinkedHashMap(Map<? extends K, ? extends V> m)

    Constructs a new `LinkedHashMap` instance containing the mappings from the specified map. The order of the elements is preserved.

    ###### Parameters

    - `m`: the mappings to add.

- ## Method Details

  - ### containsValue

    public boolean containsValue(Object value)
    Description copied from class: `HashMap`

    Returns whether this map contains the specified value.

    ###### Parameters

    - `value`: the value to search for.

    ###### Returns

    Specified by:
      `containsValue` in interface `Map<K,V>`
    Overrides:
      `containsValue` in class `HashMap<K,V>`
    Returns:
      `true` if this map contains the specified value, `false` otherwise.

  - ### get

    public V get(Object key)

    Returns the value of the mapping with the specified key.

    ###### Parameters

    - `key`: the key.

    ###### Returns

    Specified by:
      `get` in interface `Map<K,V>`
    Overrides:
      `get` in class `HashMap<K,V>`
    Returns:
      the value of the mapping with the specified key, or `null` if no mapping for the specified key is found.

  - ### put

    public V put(K key, V value)

    Maps the specified key to the specified value.

    ###### Parameters

    - `key`: the key.

    - `value`: the value.

    ###### Returns

    Specified by:
      `put` in interface `Map<K,V>`
    Overrides:
      `put` in class `HashMap<K,V>`
    Returns:
      the value of any previous mapping with the specified key or `null` if there was no such mapping.

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()

    Returns a set containing all of the mappings in this map. Each mapping is an instance of `Map.Entry`. As the set is backed by this map, changes in one will be reflected in the other.

    ###### Returns

    a set of the mappings.

    Specified by:
      `entrySet` in interface `Map<K,V>`
    Overrides:
      `entrySet` in class `HashMap<K,V>`

  - ### keySet

    public Set<K> keySet()

    Returns a set of the keys contained in this map. The set is backed by this map so changes to one are reflected by the other. The set does not support adding.

    ###### Returns

    a set of the keys.

    Specified by:
      `keySet` in interface `Map<K,V>`
    Overrides:
      `keySet` in class `HashMap<K,V>`

  - ### values

    public Collection<V> values()

    Returns a collection of the values contained in this map. The collection is backed by this map so changes to one are reflected by the other. The collection supports remove, removeAll, retainAll and clear operations, and it does not support add or addAll operations.

    This method returns a collection which is the subclass of AbstractCollection. The iterator method of this subclass returns a "wrapper object" over the iterator of map's entrySet(). The size method wraps the map's size method and the contains method wraps the map's containsValue method.

    The collection is created when this method is called for the first time and returned in response to all subsequent calls. This method may return different collections when multiple concurrent calls occur, since no synchronization is performed.

    ###### Returns

    a collection of the values contained in this map.

    Specified by:
      `values` in interface `Map<K,V>`
    Overrides:
      `values` in class `HashMap<K,V>`

  - ### remove

    public V remove(Object key)

    Removes the mapping with the specified key from this map.

    ###### Parameters

    - `key`: the key of the mapping to remove.

    ###### Returns

    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `HashMap<K,V>`
    Returns:
      the value of the removed mapping or `null` if no mapping for the specified key was found.

  - ### removeEldestEntry

    protected boolean removeEldestEntry(Map.Entry<K,V> eldest)

    This method is queried from the put and putAll methods to check if the eldest member of the map should be deleted before adding the new member. If this map was created with accessOrder = true, then the result of removeEldestEntry is assumed to be false.

    ###### Parameters

    - `eldest`: the entry to check if it should be removed.

    ###### Returns

    `true` if the eldest member should be removed.

  - ### clear

    public void clear()

    Removes all elements from this map, leaving it empty.

    ###### See also

    - #isEmpty()

    - #size()

    Specified by:
      `clear` in interface `Map<K,V>`
    Overrides:
      `clear` in class `HashMap<K,V>`